var http = require('http'),
  fs = require('fs'),
  util = require('util'),
  redis = require('redis');

var _ex = module.exports;

_ex.getConfig = function getConfig(cb) {
  fs.readFile('./test/config.json', function(err, data) {
    if(err) throw err;
    cb(JSON.parse(data));
  });
};

_ex.start_redis = function start_redis() {
  var exec = require('child_process').spawn('bash');
  exec.stdin.write('~/dev/lib/redis-2.4.5/src/redis-server');
  exec.stdin.end();
};

_ex.stop_redis = function stop_redis() {
  var client = redis.createClient();
  client.flushall();
  client.shutdown();
  client.quit();
};

_ex.upload_pic = function upload_pic() {

  function EncodeFieldPart(boundary, name, value) {
    var return_part = "--" + boundary + "\r\n";
    return_part += "Content-Disposition: form-data; name=\"" + name + "\"\r\n\r\n";
    return_part += value + "\r\n";
    return return_part;
  }

  function EncodeFilePart(boundary, type, name, filename) {
    var return_part = "--" + boundary + "\r\n";
    return_part += "Content-Disposition: form-data; name=\"" + name + "\"; filename=\"" + filename + "\"\r\n";
    return_part += "Content-Type: " + type + "\r\n\r\n";
    return return_part;
  }

  function PreparePost() {
    var boundary = Math.random();
    var post_data = [];

    post_data.push(new Buffer(EncodeFieldPart(boundary, 'field1', 'value1'), 'ascii'));
    post_data.push(new Buffer(EncodeFieldPart(boundary, 'field2', 'value2'), 'ascii'));
    post_data.push(new Buffer(EncodeFilePart(boundary, 'image/png', 'img/file', 'node.png'), 'ascii'));

    var file_reader = fs.createReadStream('test/node.png');
    var file_contents = '';
    file_reader.on('data', function(data) {
      file_contents += data;
    });
    file_reader.on('end', function() {
      post_data.push(new Buffer(file_contents, 'utf8'));
      post_data.push(new Buffer("\r\n--" + boundary + "--"), 'ascii');

      MakePost(post_data, boundary);
    });
  }

  function MakePost(post_data, boundary) {

    var length = 0;

    for(var i = 0; i < post_data.length; i++) {
      length += post_data[i].length;
    }

    var post_options = {
      port: '8080',
      path: '/upload',
      method: 'POST',
      headers: {
        'Content-Type': 'multipart/form-data; boundary=' + boundary,
        'Content-Length': length
      }
    };

    var post_request = http.request(post_options, function(response) {
      response.setEncoding('utf8');
      response.on('data', function(chunk) {
        console.log(chunk);
      });
    });

    for(i = 0; i < post_data.length; i++) {
      post_request.write(post_data[i]);
    }
    post_request.end();
  }

  PreparePost();

};